parameters:
    sylius.security.admin_regex: "^/admin"
    sylius.security.shop_regex: "^/(?!admin|new-api|api/.*|api$|media/.*)[^/]++"
    sylius.security.new_api_route: "/api/v2"
    sylius.security.new_api_regex: "^%sylius.security.new_api_route%"

security:
    always_authenticate_before_granting: true
    providers:
        sylius_admin_user_provider:
            id: sylius.admin_user_provider.email_or_name_based
        sylius_api_admin_user_provider:
            id: sylius.admin_user_provider.email_or_name_based
        sylius_shop_user_provider:
            id: sylius.shop_user_provider.email_or_name_based
        sylius_api_shop_user_provider:
            id: sylius.shop_user_provider.email_or_name_based
        sylius_api_chain_provider:
            chain:
                providers: [sylius_api_shop_user_provider, sylius_api_admin_user_provider]

    encoders:
        Sylius\Component\User\Model\UserInterface: argon2i
    firewalls:
        admin:
            switch_user: true
            context: admin
            pattern: "%sylius.security.admin_regex%"
            provider: sylius_admin_user_provider
            form_login:
                provider: sylius_admin_user_provider
                login_path: sylius_admin_login
                check_path: sylius_admin_login_check
                failure_path: sylius_admin_login
                default_target_path: sylius_admin_dashboard
                use_forward: false
                use_referer: true
                csrf_token_generator: security.csrf.token_manager
                csrf_parameter: _csrf_admin_security_token
                csrf_token_id: admin_authenticate
            remember_me:
                secret: "%env(APP_SECRET)%"
                path: /admin
                name: APP_ADMIN_REMEMBER_ME
                lifetime: 31536000
                remember_me_parameter: _remember_me
            logout:
                path: sylius_admin_logout
                target: sylius_admin_login
            anonymous: true

        new_api_admin_user:
            pattern: "%sylius.security.new_api_route%/admin-user-authentication-token"
            provider: sylius_admin_user_provider
            stateless: true
            anonymous: true
            json_login:
                check_path: "%sylius.security.new_api_route%/admin-user-authentication-token"
                username_path: email
                password_path: password
                success_handler: lexik_jwt_authentication.handler.authentication_success
                failure_handler: lexik_jwt_authentication.handler.authentication_failure
            guard:
                authenticators:
                    - lexik_jwt_authentication.jwt_token_authenticator

        new_api_shop_user:
            pattern: "%sylius.security.new_api_route%/shop-user-authentication-token"
            provider: sylius_shop_user_provider
            stateless: true
            anonymous: true
            json_login:
                check_path: "%sylius.security.new_api_route%/shop-user-authentication-token"
                username_path: email
                password_path: password
                success_handler: lexik_jwt_authentication.handler.authentication_success
                failure_handler: lexik_jwt_authentication.handler.authentication_failure
            guard:
                authenticators:
                    - lexik_jwt_authentication.jwt_token_authenticator

        new_api:
            pattern: "%sylius.security.new_api_regex%/*"
            provider: sylius_api_chain_provider
            stateless: true
            anonymous: lazy
            guard:
                authenticators:
                    - lexik_jwt_authentication.jwt_token_authenticator

        shop:
            switch_user: { role: ROLE_ALLOWED_TO_SWITCH }
            context: shop
            pattern: "%sylius.security.shop_regex%"
            provider: sylius_shop_user_provider
            form_login:
                success_handler: sylius.authentication.success_handler
                failure_handler: sylius.authentication.failure_handler
                provider: sylius_shop_user_provider
                login_path: sylius_shop_login
                check_path: sylius_shop_login_check
                failure_path: sylius_shop_login
                default_target_path: sylius_shop_homepage
                use_forward: false
                use_referer: true
                csrf_token_generator: security.csrf.token_manager
                csrf_parameter: _csrf_shop_security_token
                csrf_token_id: shop_authenticate
            remember_me:
                secret: "%env(APP_SECRET)%"
                name: APP_SHOP_REMEMBER_ME
                lifetime: 31536000
                remember_me_parameter: _remember_me
            logout:
                path: sylius_shop_logout
                target: sylius_shop_login
                invalidate_session: false
                success_handler: sylius.handler.shop_user_logout
            anonymous: true

        dev:
            pattern:  ^/(_(profiler|wdt)|css|images|js)/
            security: false

    access_control:
        - { path: "%sylius.security.admin_regex%/_partial", role: IS_AUTHENTICATED_ANONYMOUSLY, ips: [127.0.0.1, ::1] }
        - { path: "%sylius.security.admin_regex%/_partial", role: ROLE_NO_ACCESS }
        - { path: "%sylius.security.shop_regex%/_partial", role: IS_AUTHENTICATED_ANONYMOUSLY, ips: [127.0.0.1, ::1] }
        - { path: "%sylius.security.shop_regex%/_partial", role: ROLE_NO_ACCESS }

        - { path: "%sylius.security.admin_regex%/login", role: IS_AUTHENTICATED_ANONYMOUSLY }
        - { path: "%sylius.security.shop_regex%/login", role: IS_AUTHENTICATED_ANONYMOUSLY }

        - { path: "%sylius.security.shop_regex%/register", role: IS_AUTHENTICATED_ANONYMOUSLY }
        - { path: "%sylius.security.shop_regex%/verify", role: IS_AUTHENTICATED_ANONYMOUSLY }

        - { path: "%sylius.security.admin_regex%", role: ROLE_ADMINISTRATION_ACCESS }
        - { path: "%sylius.security.shop_regex%/account", role: ROLE_USER }
